#include <stdio.h>
#include <string.h>
#include <assert.h>

#define UALL_INLINE static
#include <libualloc/libualloc.h>
#include <libualloc/libualloc_impl.h>

#include "tester_rnd.c"
#include "tester_pool.c"


#define TESTER_SLAB_AP
#include "tester_slab.c"

#undef TESTER_SLAB_AP
#include "tester_slab.c"

#include "tester_stackd.c"
#include "tester_stackdnp.c"
#include "tester_stacks.c"
#include "tester_mcache.c"
#include "tester_acache.c"


int main(int argc, char *argv[])
{
	const char *backend = argv[1];

	argv++;
	argc--;

	if (backend == NULL) {
		fprintf(stderr, "Need a backend\n");
		return 1;
	}

	if (strcmp(backend, "slab") == 0)     return main_slab(argc, argv);
	if (strcmp(backend, "slabap") == 0)   return main_slabap(argc, argv);
	if (strcmp(backend, "stacks") == 0)   return main_stacks(argc, argv);
	if (strcmp(backend, "stackd") == 0)   return main_stackd(argc, argv);
	if (strcmp(backend, "stackdnp") == 0) return main_stackdnp(argc, argv);
	if (strcmp(backend, "mcache") == 0)   return main_mcache(argc, argv);
	if (strcmp(backend, "acache") == 0)   return main_acache(argc, argv);

	fprintf(stderr, "Invalid backend: '%s'\n", backend);
	return 1;
}
